Subject: [tsvwg] Query regarding sending ABORT in SCTP RFC 4960

From: Shweta r <[email-masked]>
Date: Fri, 10 Mar 2017 11:53:36 +0000

Hi Group,

Greetings. I have a doubt regarding SCTP RFC 4960, section "9.1.  Abort of an Association".

Doubt 1:

1) Section 3.3.2.  Initiation (INIT) (1)

      If the value of the Initiate Tag in a received INIT chunk is found
      to be 0, the receiver MUST treat it as an error and close the
      association by transmitting an ABORT.

      --> Here clearly it is written to close the association when sending ABORT

2)Section 5.1.  Normal Establishment of an Association

   If an endpoint receives an INIT, INIT ACK, or COOKIE ECHO chunk but
   decides not to establish the new association due to missing mandatory
   parameters in the received INIT or INIT ACK, invalid parameter
   values, or lack of local resources, it SHOULD respond with an ABORT
   chunk.  It SHOULD also specify the cause of abort, such as the type
   of the missing mandatory parameters, etc., by including the error
   cause parameters with the ABORT chunk.  The Verification Tag field in
   the common header of the outbound SCTP packet containing the ABORT
   chunk MUST be set to the Initiate Tag value of the peer.

-->When the endpoint is client and receives INIT-ACK with invalid parameter, it should send only ABORT and don't disturb the existing association
    or stack should send ABORT and close the association  ?

Doubt 2 :

5.2.1.  INIT Received in COOKIE-WAIT or COOKIE-ECHOED State (Item B)

Upon receipt of an INIT in the COOKIE-ECHOED state, an endpoint MUST
   respond with an INIT ACK using the same parameters it sent in its
   original INIT chunk (including its Initiate Tag, unchanged), provided
   that no NEW address has been added to the forming association.  If
   the INIT message indicates that a new address has been added to the
   association, then the entire INIT MUST be discarded, and NO changes
   should be made to the existing association.  An ABORT SHOULD be sent
   in response that MAY include the error 'Restart of an association
   with new addresses'.  The error SHOULD list the addresses that were
   added to the restarting association.

---> Other than the scenarios of new address adding, in all other cases, sending ABORT means send ABORT and  close the existing association ?

Regards
Shweta

---

From: Michael Tuexen <[email-masked]>
Date: Fri, 10 Mar 2017 22:18:47 +0100

> On 10 Mar 2017, at 12:53, Shweta r <[email-masked]> wrote:
> 
> Hi Group,
>  
> Greetings. I have a doubt regarding SCTP RFC 4960, section “9.1.  Abort of an Association”.
>  
> Doubt 1:
>  
Yepp.
> -->When the endpoint is client and receives INIT-ACK with invalid parameter, it should send only ABORT and don’t disturb the existing association   
The text doesn't describe whether the receiver of an INIT-ACK with an invalid parameter
has to stop the association setup procedure or can continue with it.
So an endpoint could just drop the INIT-ACK and retransmit the INIT in the hope
that the next INIT-ACK is better. But if the endpoint decides not to establish
the association, sending an ABORT is a good thing.
> ---> Other than the scenarios of new address adding, in all other cases, sending ABORT means send ABORT and  close the existing association ?
I guess so...

Best regards
Michael